<?php
/**
 * Perform a simple text replace
 * This should be used when the string does not contain HTML
 * (off by default)
 */
define('STR_HIGHLIGHT_SIMPLE', 1);

/**
 * Only match whole words in the string
 * (off by default)
 */
define('STR_HIGHLIGHT_WHOLEWD', 2);

/**
 * Case sensitive matching
 * (on by default)
 */
define('STR_HIGHLIGHT_CASESENS', 0);

/**
 * Overwrite links if matched
 * This should be used when the replacement string is a link
 * (off by default)
 */
define('STR_HIGHLIGHT_STRIPLINKS', 8);

/**
 * Highlight a string in text without corrupting HTML tags
 *
 * @author      Aidan Lister <aidan@php.net>
 * @version     3.1.0
 * @param       string          $text           Haystack - The text to search
 * @param       array|string    $needle         Needle - The string to highlight
 * @param       bool            $options        Bitwise set of options
 * @param       array           $highlight      Replacement string
 * @return      Text with needle highlighted
 */
function str_highlight($text, $needle='', $options = null, $highlight = null)
{
	if (!$needle) return $text;
    // Default highlighting
    if ($highlight === null) {
        $highlight = '<strong class="highlight">\1</strong>';
    }

    // Select pattern to use
    if ($options & STR_HIGHLIGHT_SIMPLE) {
        $pattern = '#(%s)#';
    } else {
        $pattern = '#(?!<.*?)(%s)(?![^<>]*?>)#';
        $sl_pattern = '#<a\s(?:.*?)>(%s)</a>#';
    }

    // Case sensitivity
/*
    if ($options ^ STR_HIGHLIGHT_CASESENS) {

        $pattern .= 'i';
        $sl_pattern .= 'i';
    }
*/
        $pattern .= 'i';
        $sl_pattern .= 'i';

    $needle = (array) $needle;
    foreach ($needle as $needle_s) {
        $needle_s = preg_quote($needle_s);

        // Escape needle with optional whole word check
        if ($options & STR_HIGHLIGHT_WHOLEWD) {
            $needle_s = '\b' . $needle_s . '\b';
        }

        // Strip links
        if ($options & STR_HIGHLIGHT_STRIPLINKS) {
            $sl_regex = sprintf($sl_pattern, $needle_s);
            $text = preg_replace($sl_regex, '\1', $text);
        }

        $regex = sprintf($pattern, $needle_s);
        $text = preg_replace($regex, $highlight, $text);
    }

    return $text;
}
$pages = !$get['page'] ? 1 : $get['page'];
$limit = 4;
$start_limit = ($pages - 1) * $limit;

$status_p_c = ' and c.status = 1 and p.products_status = 1';
if (MANUAL_ORDERS_SHOW_DISABLED_PRODUCTS > 0) {
	$status_p_c = '';
}

if ($get['q']) {

	$totstr="select pd.products_shortdescription,p.products_image, p.products_id, p.products_price, pd.products_name, IF(s.status, s.specials_new_products_price, p.products_price) as final_price from tx_multishop_products_description pd, tx_multishop_products p left join tx_multishop_specials s on p.products_id = s.products_id left join tx_multishop_manufacturers m on p.manufacturers_id = m.manufacturers_id, tx_multishop_categories c, tx_multishop_products_to_categories p2c where pd.products_name like '%".addslashes($get['q'])."%' and p.products_id = pd.products_id and p.products_id = p2c.products_id and c.categories_id = p2c.categories_id".$status_p_c." and p.page_uid='".$this->showCatalogFromPage."' group by p.products_id order by pd.products_name asc";
	$totqry = $GLOBALS['TYPO3_DB']->sql_query($totstr);
	$totrow = $GLOBALS['TYPO3_DB']->sql_num_rows($totqry);
	$totpage = ceil($totrow / $limit);
	if ($pages > $totpage) {
		$get['page'] = $totpage;
	}

	$str="select p2c.categories_id, pd.products_shortdescription,p.products_image, p.products_id, p.products_price, pd.products_name, IF(s.status, s.specials_new_products_price, p.products_price) as final_price from tx_multishop_products_description pd, tx_multishop_products p left join tx_multishop_specials s on p.products_id = s.products_id left join tx_multishop_manufacturers m on p.manufacturers_id = m.manufacturers_id, tx_multishop_categories c, tx_multishop_products_to_categories p2c where pd.products_name like '%".addslashes($get['q'])."%' and p.products_id = pd.products_id and p.products_id = p2c.products_id and c.categories_id = p2c.categories_id".$status_p_c." and p.page_uid='".$this->showCatalogFromPage."' group by p.products_id order by pd.products_name asc limit ".$start_limit.", ".$limit;

} else {
	exit;
}
$qry=$GLOBALS['TYPO3_DB']->sql_query($str) or die($str.' --- '. $GLOBALS['TYPO3_DB']->sql_error());
$numrows = $GLOBALS['TYPO3_DB']->sql_num_rows($qry);
if ($numrows > 0) {
	while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
	{
		if (!$tr_type or $tr_type=='even') 	$tr_type='odd';
		else								$tr_type='even';
		if ($row['categories_id'])
		{
			// get all cats to generate multilevel fake url
			$level=0;
			$cats=mslib_fe::Crumbar($row['categories_id']);
			$cats=array_reverse($cats);
			$where='';
			if (count($cats) > 0)
			{
				foreach ($cats as $cat)
				{
					$where.="categories_id[".$level."]=".$cat['id']."&";
					$level++;
				}
				$where=substr($where,0,(strlen($where)-1));
				$where.='&';
			}
			// get all cats to generate multilevel fake url eof
		}
		//$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&products_id='.$row['products_id'].'&tx_multishop_pi1[page_section]=products_detail&skeywords='.urlencode($get['q']));
		
		if ($_GET['dt'] == 1) {
			echo '<li class="'.$tr_type.'" onselect="this.text.value = \''.addslashes($row['products_name']).'\'; fillProductData('. $row['products_id'] .', 1)">';
		} else {
			echo '<li class="'.$tr_type.'" onselect="this.text.value = \''.addslashes($row['products_name']).'\'; fillProductData('. $row['products_id'] .', 2)">';
		}
echo '<div class="ajax_products_image">';

		if ($row['products_image']) 	echo '<img src="'.$ms['image_paths']['products']['50'].'/'.$row['products_image'].'">';
		
echo '</div>
<div class="ajax_products_search_item">
';
echo '<div class="ajax_products_name">'.substr($row['products_name'],0,50).'</div><div class="ajax_products_shortdescription">'.addslashes(str_highlight(substr($row['products_shortdescription'],0,75),$get['q'])).'</div>';
if ($row['products_price'] <> $row['final_price'])
{
	echo '<div class="ajax_old_price">'.mslib_fe::Money2Cents($row['products_price']).'</div><div class="ajax_specials_price">'.mslib_fe::Money2Cents($row['final_price']).'</div>';
}
else
{
	echo '<div class="ajax_products_price">'.mslib_fe::Money2Cents($row['products_price']).'</div>';
}
echo '</div></li>';
	}

	if (!isset($get['page'])) {
		if ($totpage > 1) {
			echo '<li class="autofill_more" onselect=" this.custom_uri = \'&page=2\'; this.request(); ">'.htmlspecialchars($this->pi_getLL('more_results')).' &raquo;</li>';
		}
	} else {
		if ($get['page'] < $totpage) {
			echo '<li class="autofill_more" onselect=" this.custom_uri = \'&page=' . ($pages + 1) . '\'; this.request(); ">'.htmlspecialchars($this->pi_getLL('more_results')).' &raquo;</li>';
		}
	}
}
	exit;
?>